/**
 * @author Nels Oscar
 * 2010
 * GUI elements that handle rollover.
 */
public class Button{
  
  String name;
  
  int w,h,x,y;
  
  PFont font;
  
  boolean mouseOver=false;
  
  color dead=color(0);
  
  color alive=color(150);
  
  
  public Button(String n, int X, int Y, int W, int H,PFont f){
    name=n;
    x=X;
    y=Y;
    w=W;
    h=H;
    font=f;
  }
  
  public void show(){  
    if(mouseOver){
      fill(alive);
      stroke(dead);
    }else{
      fill(dead);
      stroke(alive);
    }
    rect(x,y,w,h);
    if(mouseOver){
      fill(dead);
    }else{
      fill(alive);
    }
    textFont(font);
    text(name,x+5,y+20);
  }
  
  public void live(boolean que){
    mouseOver=que;
    show();
  }
  
  public boolean contains(int X, int Y){
    return (x <= X && X < x + w &&
            y <= Y && Y < y + h   );
  }
}
