/**
 * Nels Oscar
 * 2010
 * A block handler to abstract the end user away from handling individual
 * graphics compnents to get at useful data.
 */

public class Grid{
  
  Block[] grid;

  int w,h,numR;
  
  int spaceX;
  int spaceY;
  
  public Grid(int W, int H, int num){
    w=W;
    h=H;
    numR=num;
    spaceX=w/numR;
    spaceY=h/numR;
    grid=new Block[numR*numR];
    int cnt=0;
    for(int i=0; i<w; i+=spaceX){
      for(int j=0; j<h; j+=spaceY){
        grid[cnt++]=new Block(j,i,spaceX,spaceY);
      }
    }
    for(int i=0; i<grid.length; i++)
      grid[i].show();
  }

  void showBlocks(){
    for(int i=0; i<grid.length; i++)
      grid[i].show();
  }

  void update(int x, int y){
    int i=0;
    while(!grid[i++].contains(x,y) && i<grid.length){}
    i--;
    grid[i].live();
    grid[i].show();
    println(grid[i]);
  }
  
  Block[] getGrid(){
    return grid;
  }
  
  public void clear(){
    for(int i=0; i<grid.length; i++){
      grid[i].clear();
    }
    showBlocks();
  }
  
  public int getLongestRow(){
    int row=0;
    int longest=-1;
    int accum=0;
    int oldAccum=0;
    while(row<numR){
      accum=0;
      for(int col=0; col<numR; col++){
        if(grid[row*numR+col].isLit()){
          accum=col;
        }
      }
      if(accum>oldAccum && row>longest){
        longest=row;
        oldAccum=accum;
      }
      row++;
    }

    return accum;
  }
  
  Phrase[] parseGrid(){
    Phrase[] phr=new Phrase[numR];
    for(int row=0; row<numR; row++){
      phr[row]=new Phrase();
      for(int col=0; col<numR; col++){
        if(grid[row*numR+col].isLit())
          phr[row].addNote(new Note(row+30,.25,100));
        else{
          phr[row].addRest(new Rest(0.25));
        }
      }
    }
    return phr;
  }
}
